---
title: Module
metaTitle: Module - API Reference - Handsontable Documentation
permalink: /10.0/api/module
canonicalUrl: /api/module
hotPlugin: false
editLink: false
---

# Module

[[toc]]
## Methods

### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/helpers/wrappers/jquery.js#L4

:::

_module.[exports](@/api/exports.md)([Handsontable](@/api/core.md))_


| Param | Type | Description |
| --- | --- | --- |
| Handsontable | `Core` | The Handsontable instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/i18n/phraseFormatters/pluralize.js#L9

:::

_module.[exports](@/api/exports.md)(phrasePropositions, pluralForm) ⇒ string | Array_

Try to choose plural form from available phrase propositions.


| Param | Type | Description |
| --- | --- | --- |
| phrasePropositions | `Array` | List of phrases propositions. |
| pluralForm | `number` | Number determining which phrase form should be used. |


**Returns**: `string` | `Array` - One particular phrase if it's possible, list of unchanged phrase propositions otherwise.  

### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/i18n/phraseFormatters/substituteVariables.js#L11

:::

_module.[exports](@/api/exports.md)(phrasePropositions, zippedVariablesAndValues) ⇒ string_

Try to substitute variable inside phrase propositions.


| Param | Type | Description |
| --- | --- | --- |
| phrasePropositions | `Array` | List of phrases propositions. |
| zippedVariablesAndValues | `object` | Object containing variables and corresponding values. |


**Returns**: `string` - Phrases with substituted variables if it's possible, list of unchanged phrase propositions otherwise.  

### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/alignment.js#L10

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/clearColumn.js#L9

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/columnLeft.js#L9

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/columnRight.js#L10

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/noItems.js#L8

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/readOnly.js#L10

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/redo.js#L8

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/removeColumn.js#L10

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/removeRow.js#L10

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/rowAbove.js#L9

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/rowBelow.js#L10

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/separator.js#L6

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/contextMenu/predefinedItems/undo.js#L8

:::

_module.[exports](@/api/exports.md)() ⇒ object_



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/copyPaste/contextMenuItem/copy.js#L7

:::

_module.[exports](@/api/exports.md)(copyPastePlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| copyPastePlugin | `CopyPaste` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/copyPaste/contextMenuItem/cut.js#L7

:::

_module.[exports](@/api/exports.md)(copyPastePlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| copyPastePlugin | `CopyPaste` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/customBorders/contextMenuItem/bottom.js#L8

:::

_module.[exports](@/api/exports.md)(customBordersPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| customBordersPlugin | `CustomBorders` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/customBorders/contextMenuItem/left.js#L8

:::

_module.[exports](@/api/exports.md)(customBordersPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| customBordersPlugin | `CustomBorders` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/customBorders/contextMenuItem/noBorders.js#L8

:::

_module.[exports](@/api/exports.md)(customBordersPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| customBordersPlugin | `CustomBorders` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/customBorders/contextMenuItem/right.js#L8

:::

_module.[exports](@/api/exports.md)(customBordersPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| customBordersPlugin | `CustomBorders` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/customBorders/contextMenuItem/top.js#L8

:::

_module.[exports](@/api/exports.md)(customBordersPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| customBordersPlugin | `CustomBorders` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/exportFile/typeFactory.js#L17

:::

_module.[exports](@/api/exports.md)(type, dataProvider, options) ⇒ BaseType | null_


| Param | Type | Description |
| --- | --- | --- |
| type | `string` | The exporter type. |
| dataProvider | `DataProvider` | The data provider. |
| options | `object` | Constructor options for exporter class. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/filters/constants.js#L128

:::

_module.[exports](@/api/exports.md)(type) ⇒ object_

Get options list for conditional filter by data type (e.q: `'text'`, `'numeric'`, `'date'`).


| Param | Type | Description |
| --- | --- | --- |
| type | `string` | The data type. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/hiddenColumns/contextMenuItem/hideColumn.js#L7

:::

_module.[exports](@/api/exports.md)(hiddenColumnsPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| hiddenColumnsPlugin | `HiddenColumns` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/hiddenColumns/contextMenuItem/showColumn.js#L8

:::

_module.[exports](@/api/exports.md)(hiddenColumnsPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| hiddenColumnsPlugin | `HiddenColumns` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/hiddenRows/contextMenuItem/hideRow.js#L7

:::

_module.[exports](@/api/exports.md)(hiddenRowsPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| hiddenRowsPlugin | `HiddenRows` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/hiddenRows/contextMenuItem/showRow.js#L8

:::

_module.[exports](@/api/exports.md)(hiddenRowsPlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| hiddenRowsPlugin | `HiddenRows` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/manualColumnFreeze/contextMenuItem/freezeColumn.js#L7

:::

_module.[exports](@/api/exports.md)(manualColumnFreezePlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| manualColumnFreezePlugin | `ManualColumnFreeze` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/manualColumnFreeze/contextMenuItem/unfreezeColumn.js#L7

:::

_module.[exports](@/api/exports.md)(manualColumnFreezePlugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| manualColumnFreezePlugin | `ManualColumnFreeze` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/plugins/mergeCells/contextMenuItem/toggleMerge.js#L8

:::

_module.[exports](@/api/exports.md)(plugin) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| plugin | `*` | The plugin instance. |



### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/utils/sortingAlgorithms/mergeSort.js#L45

:::

_module.[exports](@/api/exports.md)(array, compareFunction, startIndex, endIndex) ⇒ Array_

Mergesort method which is recursively called for sorting the input array.


| Param | Type | Description |
| --- | --- | --- |
| array | `Array` | The array which should be sorted. |
| compareFunction | `function` | Compares two items in an array. If compareFunction is not supplied, elements are sorted by converting them to strings and comparing strings in Unicode code point order. |
| startIndex | `number` | Left side of the subarray. |
| endIndex | `number` | Right side of the subarray. |


**Returns**: `Array` - Array with sorted subarray.  

### exports
  
::: source-code-link https://github.com/handsontable/handsontable/blob/8ad9e39bea09f559dc24962196541af30811a8c3/../src/utils/staticRegister.js#L7

:::

_module.[exports](@/api/exports.md)(namespace) ⇒ object_


| Param | Type | Description |
| --- | --- | --- |
| namespace | `string` | The namespace for the storage. |


